function RC4Struct() {
this.x = 0;
this.y = 0;
this.s = new Array(256);
}

RC4Struct.prototype = {
constructor: RC4Struct,
NextByte: function() {
this.x = this.x + 1 & 255;
this.y = this.y + this.s[this.x] & 255;
var o = this.s[this.x];
this.s[this.x] = this.s[this.y];
this.s[this.y] = o;
return this.s[this.s[this.x] + this.s[this.y] & 255];
},
NextLong: function() {
return this.NextByte() + (this.NextByte() << 8) + (this.NextByte() << 16) + (this.NextByte() << 24);
},
InitZero: function() {
this.x = 0;
this.y = 0;
for (var o = 0; o < 256; o++) this.s[o] = o;
for (o = 0; o < 256; o++) {
var t = t + this.s[o] & 255, i = this.s[o];
this.s[o] = this.s[t];
this.s[t] = i;
}
}
};

function ZobristStruct() {
this.dwKey = 0;
this.dwLock0 = 0;
this.dwLock1 = 0;
}

ZobristStruct.prototype = {
constructor: ZobristStruct,
InitZero: function() {
this.dwKey = 0;
this.dwLock0 = 0;
this.dwLock1 = 0;
},
InitRC4: function(o) {
this.dwKey = o.NextLong();
this.dwLock0 = o.NextLong();
this.dwLock1 = o.NextLong();
},
Xor: function(o) {
this.dwKey ^= o.dwKey;
this.dwLock0 ^= o.dwLock0;
this.dwLock1 ^= o.dwLock1;
},
Xor2: function(o, t) {
this.dwKey ^= o.dwKey ^ t.dwKey;
this.dwLock0 ^= o.dwLock0 ^ t.dwLock0;
this.dwLock1 ^= o.dwLock1 ^ t.dwLock1;
}
};

function MoveStruct() {
this.wmv = 0;
this.ucpcCaptured = 0;
this.ucbCheck = !1;
this.dwKey = 0;
}

MoveStruct.prototype = {
constructor: MoveStruct,
Set: function(o, t, i, e) {
this.wmv = o;
this.ucpcCaptured = t;
this.ucbCheck = i;
this.dwKey = e;
}
};

window.Zobrist = {};

Zobrist.Player = new ZobristStruct();

Zobrist.Table = new Array(14);

Zobrist.InitZobrist = function() {
var o = new RC4Struct();
o.InitZero();
Zobrist.Player.InitRC4(o);
for (var t = 0; t < 14; t++) {
for (var i = new Array(256), e = 0; e < 256; e++) {
i[e] = new ZobristStruct();
i[e].InitRC4(o);
}
Zobrist.Table[t] = i;
}
};

window.CompareHistory = function(o, t) {
return Search.nHistoryTable[t] - Search.nHistoryTable[o];
};

window.MvvLva = function(o) {
return (gCommon.cucMvvLva[gCommon.BoardMap[gCommon.DST(o)]] << 3) - gCommon.cucMvvLva[gCommon.BoardMap[gCommon.SRC(o)]];
};

window.CompareMvvLva = function(o, t) {
return MvvLva(t) - MvvLva(o);
};

window.gGameBoard = function() {
this.BoardMap = gCommon.BoardMap;
this.BoardNodes = new Array(256);
this.sdPlayer = 0;
this.isGameOver = 0;
this.sqSelected = 0;
this.mvsList = new Array();
this.nDistance = 0;
this.nMoveNum = 0;
this.mvLast = 0;
this.nodeDic = {
8: [],
9: [],
10: [],
11: [],
12: [],
13: [],
14: [],
16: [],
17: [],
18: [],
19: [],
20: [],
21: [],
22: []
};
this.vlWhite = 0;
this.vlBlack = 0;
this.zobr = new ZobristStruct();
for (var o = 0; o < gCommon.MAX_MOVES; o++) this.mvsList.push(new MoveStruct());
Zobrist.InitZobrist();
};

gGameBoard.prototype = {
constructor: gGameBoard,
SetIrrev: function() {
this.mvsList[0].Set(0, 0, this.Checked(), this.zobr.dwKey);
},
InCheck: function() {
return this.mvsList[this.nMoveNum - 1].ucbCheck;
},
Captured: function() {
return 0 != this.mvsList[this.nMoveNum - 1].ucpcCaptured;
},
ClearBoard: function() {
this.sdPlayer = 0;
this.isGameOver = 0;
this.sqSelected = 0;
this.nDistance = 0;
this.vlWhite = 0;
this.vlBlack = 0;
this.nMoveNum = 1;
this.mvLast = 0;
for (var o = gCommon.FILE_LEFT; o <= gCommon.FILE_RIGHT; o++) for (var t = gCommon.RANK_TOP; t <= gCommon.RANK_BOTTOM; t++) {
var i = gCommon.COORD_XY(o, t);
this.BoardMap[i] = 0;
this.BoardNodes[i] = 0;
}
this.zobr.InitZero();
this.SetIrrev();
Zobrist.InitZobrist();
},
ChangeSide: function() {
this.sdPlayer = 1 - this.sdPlayer;
this.zobr.Xor(Zobrist.Player);
},
AddQz: function(o, t) {
this.BoardMap[o] = t;
if (t < 16 && 0 != t) {
this.vlWhite += gCommon.cucvlPiecePos[t - 8][o];
this.zobr.Xor(Zobrist.Table[t - 8][o]);
} else if (0 != t) {
this.vlBlack += gCommon.cucvlPiecePos[t - 16][gCommon.SQUARE_FLIP(o)];
this.zobr.Xor(Zobrist.Table[t - 9][o]);
}
},
DelQz: function(o, t) {
this.BoardMap[o] = 0;
if (t < 16 && 0 != t) {
this.vlWhite -= gCommon.cucvlPiecePos[t - 8][o];
this.zobr.Xor(Zobrist.Table[t - 8][o]);
} else if (0 != t) {
this.vlBlack -= gCommon.cucvlPiecePos[t - 16][gCommon.SQUARE_FLIP(o)];
this.zobr.Xor(Zobrist.Table[t - 9][o]);
}
},
MovePiece: function(o) {
var t = gCommon.SRC(o), i = gCommon.DST(o), e = this.BoardMap[i];
0 != e && this.DelQz(i, e);
var s = this.BoardMap[t];
this.DelQz(t, s);
this.AddQz(i, s);
return e;
},
UndoMovePiece: function(o, t) {
var i = gCommon.SRC(o), e = gCommon.DST(o), s = this.BoardMap[e];
this.DelQz(e, s);
this.AddQz(i, s);
0 != t && this.AddQz(e, t);
},
NullMove: function() {
var o = this.zobr.dwKey;
this.ChangeSide();
this.mvsList[this.nMoveNum].Set(0, 0, !1, o);
this.nMoveNum++;
this.nDistance++;
},
UndoNullMove: function() {
this.nDistance--;
this.nMoveNum--;
this.ChangeSide();
},
NullOkay: function() {
return (0 == this.sdPlayer ? this.vlWhite : this.vlBlack) > gCommon.NULL_MARGIN;
},
MakeMove: function(o) {
var t = this.MovePiece(o), i = this.zobr.dwKey;
if (this.Checked()) {
this.UndoMovePiece(o, t);
return !1;
}
this.ChangeSide();
this.mvsList[this.nMoveNum].Set(o, t, this.Checked(), i);
this.nDistance++;
this.nMoveNum++;
return !0;
},
UndoMakeMove: function() {
this.nDistance--;
this.nMoveNum--;
this.ChangeSide();
var o = this.mvsList[this.nMoveNum];
this.UndoMovePiece(o.wmv, o.ucpcCaptured);
},
Evaluate: function() {
return (0 == this.sdPlayer ? this.vlWhite - this.vlBlack : this.vlBlack - this.vlWhite) + gCommon.ADVANCED_VALUE;
},
GenerateMoves: function(o) {
for (var t = new Array(), i = gCommon.SIDE_TAG(this.sdPlayer), e = gCommon.OPP_SIDE_TAG(this.sdPlayer), s = 0; s < 256; s++) {
var r = this.BoardMap[s];
if (0 != (r & i)) switch (r - i) {
case gCommon.PIECE_KING:
for (var n = 0; n < 4; n++) {
var a = s + gCommon.ccKingDelta[n];
if (gCommon.IN_FORT(a)) {
var h = this.BoardMap[a];
(o ? 0 != (h & e) : 0 == (h & i)) && t.push(gCommon.MOVE(s, a));
}
}
break;

case gCommon.PIECE_ADVISOR:
for (n = 0; n < 4; n++) {
a = s + gCommon.ccAdvisorDelta[n];
if (gCommon.IN_FORT(a)) {
h = this.BoardMap[a];
(o ? 0 != (h & e) : 0 == (h & i)) && t.push(gCommon.MOVE(s, a));
}
}
break;

case gCommon.PIECE_BISHOP:
for (n = 0; n < 4; n++) {
a = s + gCommon.ccAdvisorDelta[n];
if (gCommon.IN_BOARD(a) && gCommon.HOME_HALF(a, this.sdPlayer) && 0 == this.BoardMap[a]) {
a += gCommon.ccAdvisorDelta[n];
h = this.BoardMap[a];
(o ? 0 != (h & e) : 0 == (h & i)) && t.push(gCommon.MOVE(s, a));
}
}
break;

case gCommon.PIECE_KNIGHT:
for (n = 0; n < 4; n++) {
a = s + gCommon.ccKingDelta[n];
if (0 == this.BoardMap[a]) for (var m = 0; m < 2; m++) {
a = s + gCommon.ccKnightDelta[n][m];
if (gCommon.IN_BOARD(a)) {
h = this.BoardMap[a];
(o ? 0 != (h & e) : 0 == (h & i)) && t.push(gCommon.MOVE(s, a));
}
}
}
break;

case gCommon.PIECE_ROOK:
for (n = 0; n < 4; n++) for (a = s + (c = gCommon.ccKingDelta[n]); gCommon.IN_BOARD(a); ) {
if (0 != (h = this.BoardMap[a])) {
0 != (h & e) && t.push(gCommon.MOVE(s, a));
break;
}
o || t.push(gCommon.MOVE(s, a));
a += c;
}
break;

case gCommon.PIECE_CANNON:
for (n = 0; n < 4; n++) {
for (a = s + (c = gCommon.ccKingDelta[n]); gCommon.IN_BOARD(a); ) {
if (0 != (h = this.BoardMap[a])) break;
o || t.push(gCommon.MOVE(s, a));
a += c;
}
a += c;
for (;gCommon.IN_BOARD(a); ) {
if (0 != (h = this.BoardMap[a])) {
0 != (h & e) && t.push(gCommon.MOVE(s, a));
break;
}
a += c;
}
}
break;

case gCommon.PIECE_PAWN:
a = gCommon.SQUARE_FORWARD(s, this.sdPlayer);
if (gCommon.IN_BOARD(a)) {
h = this.BoardMap[a];
(o ? 0 != (h & e) : 0 == (h & i)) && t.push(gCommon.MOVE(s, a));
}
if (gCommon.AWAY_HALF(s, this.sdPlayer)) for (var c = -1; c <= 1; c += 2) {
a = s + c;
if (gCommon.IN_BOARD(a)) {
h = this.BoardMap[a];
(o ? 0 != (h & e) : 0 == (h & i)) && t.push(gCommon.MOVE(s, a));
}
}
}
}
return t;
},
LegalMove: function(o, t = !1) {
if (t) return !0;
var i = gCommon.SRC(o), e = this.BoardMap[i], s = gCommon.SIDE_TAG(this.sdPlayer);
if (0 == (e & s)) return !1;
var r = gCommon.DST(o), n = this.BoardMap[r];
if (0 != (n & s)) return !1;
switch (e - s) {
case gCommon.PIECE_KING:
return gCommon.IN_FORT(r) && gCommon.KING_SPAN(i, r);

case gCommon.PIECE_ADVISOR:
return gCommon.IN_FORT(r) && gCommon.ADVISOR_SPAN(i, r);

case gCommon.PIECE_BISHOP:
return gCommon.SAME_HALF(i, r) && gCommon.BISHOP_SPAN(i, r) && 0 == this.BoardMap[gCommon.BISHOP_PIN(i, r)];

case gCommon.PIECE_KNIGHT:
return (h = gCommon.KNIGHT_PIN(i, r)) != i && 0 == this.BoardMap[h];

case gCommon.PIECE_ROOK:
case gCommon.PIECE_CANNON:
var a = -1;
if (gCommon.SAME_RANK(i, r)) a = r < i ? -1 : 1; else {
if (!gCommon.SAME_FILE(i, r)) return !1;
a = r < i ? -16 : 16;
}
for (var h = i + a; h != r && 0 == this.BoardMap[h]; ) h += a;
if (h == r) return 0 == n || e - s == gCommon.PIECE_ROOK;
if (0 != n && e - s == gCommon.PIECE_CANNON) {
h += a;
for (;h != r && 0 == this.BoardMap[h]; ) h += a;
return h == r;
}
return !1;

case gCommon.PIECE_PAWN:
return !(!gCommon.AWAY_HALF(r, this.sdPlayer) || r != i - 1 && r != i + 1) || r == gCommon.SQUARE_FORWARD(i, this.sdPlayer);

default:
return !1;
}
},
Checked: function() {
for (var o = gCommon.SIDE_TAG(this.sdPlayer), t = gCommon.OPP_SIDE_TAG(this.sdPlayer), i = 0; i < 256; i++) if (this.BoardMap[i] == o + gCommon.PIECE_KING) {
if (this.BoardMap[gCommon.SQUARE_FORWARD(i, this.sdPlayer)] == t + gCommon.PIECE_PAWN) return !0;
for (var e = -1; e <= 1; e += 2) if (this.BoardMap[i + e] == t + gCommon.PIECE_PAWN) return !0;
for (var s = 0; s < 4; s++) if (0 == this.BoardMap[i + gCommon.ccAdvisorDelta[s]]) for (var r = 0; r < 2; r++) {
if ((a = this.BoardMap[i + gCommon.ccKnightCheckDelta[s][r]]) == t + gCommon.PIECE_KNIGHT) return !0;
}
for (s = 0; s < 4; s++) {
for (var n = i + (e = gCommon.ccKingDelta[s]); gCommon.IN_BOARD(n); ) {
if (0 != (a = this.BoardMap[n])) {
if (a == t + gCommon.PIECE_ROOK || a == t + gCommon.PIECE_KING) return !0;
break;
}
n += e;
}
n += e;
for (;gCommon.IN_BOARD(n); ) {
var a;
if (0 != (a = this.BoardMap[n])) {
if (a == t + gCommon.PIECE_CANNON) return !0;
break;
}
n += e;
}
}
return !1;
}
return !1;
},
IsMate: function() {
for (var o = this.GenerateMoves(!1), t = 0; t < o.length; t++) {
var i = this.MovePiece(o[t]);
if (!this.Checked()) {
this.UndoMovePiece(o[t], i);
return !1;
}
this.UndoMovePiece(o[t], i);
}
return !0;
},
DrawValue: function() {
return 0 == (1 & this.nDistance) ? -gCommon.DRAW_VALUE : gCommon.DRAW_VALUE;
},
RepStatus: function(o) {
for (var t = 1, i = !1, e = !0, s = !0, r = this.mvsList[this.nMoveNum - t]; 0 != r.wmv && 0 == r.ucpcCaptured; ) {
if (i) {
e = e && r.ucbCheck;
if (r.dwKey == this.zobr.dwKey && 0 == --o) return 1 + (e ? 2 : 0) + (s ? 4 : 0);
} else s = s && r.ucbCheck;
i = !i;
t += 1;
r = this.mvsList[this.nMoveNum - t];
}
return 0;
},
RepValue: function(o) {
var t = (0 == (2 & o) ? 0 : this.nDistance - gCommon.MATE_VALUE) + (0 == (4 & o) ? 0 : gCommon.MATE_VALUE - this.nDistance);
return 0 == t ? this.DrawValue() : t;
},
SearchQuiesc: function(o, t) {
var i = [], e = this.RepStatus(1);
if (0 != e) return this.RepValue(e);
if (this.nDistance == gCommon.LIMIT_DEPTH) return this.Evaluate();
var s = -gCommon.MATE_VALUE;
if (this.InCheck()) (i = this.GenerateMoves(!1)).sort(CompareHistory); else {
if ((e = this.Evaluate()) > s) {
s = e;
if (e >= t) return e;
e > o && (o = e);
}
(i = this.GenerateMoves(!0)).sort(CompareMvvLva);
}
for (var r = 0; r < i.length; r++) if (this.MakeMove(i[r])) {
e = -this.SearchQuiesc(-t, -o);
this.UndoMakeMove();
if (e > s) {
s = e;
if (e >= t) return e;
e > o && (o = e);
}
}
return s == -gCommon.MATE_VALUE ? this.nDistance - gCommon.MATE_VALUE : s;
},
SearchFull: function(o, t, i, e) {
var s = new SortStruct(), r = 0;
if (this.nDistance > 0) {
if (i <= 0) return this.SearchQuiesc(o, t);
if (0 != (a = this.RepStatus(1))) return this.RepValue(a);
if (this.nDistance == gCommon.LIMIT_DEPTH) return this.Evaluate();
var n = {
vlAlpha: o,
vlBeta: t,
nDepth: i,
mv: r
};
if ((a = HashTable.ProbeHash(n, this)) > -gCommon.MATE_VALUE) return a;
if (!e && !this.InCheck() && this.NullOkay()) {
this.NullMove();
var a = -this.SearchFull(-t, 1 - t, i - gCommon.NULL_DEPTH - 1, !0);
this.UndoNullMove();
if (a >= t) return a;
}
r = n.mv;
}
var h = gCommon.HASH_ALPHA, m = -gCommon.MATE_VALUE, c = 0;
s.Init(r, this);
for (var C = 0; 0 != (C = s.Next(this)); ) if (this.MakeMove(C)) {
a = -this.SearchFull(-t, -o, this.InCheck() ? i : i - 1, !1);
this.UndoMakeMove();
if (a > m) {
m = a;
if (a >= t) {
h = gCommon.HASH_BETA;
c = C;
break;
}
if (a > o) {
h = gCommon.HASH_PV;
c = C;
o = a;
}
if (globalVar.aiReStatus >= 3) break;
}
}
if (m == -gCommon.MATE_VALUE) return this.nDistance - gCommon.MATE_VALUE;
HashTable.RecordHash({
nHashFlag: h,
vlBest: m,
nDepth: i,
mv: c
}, this);
if (0 != c) {
HashTable.SetBestMove(c, i, this);
0 == this.nDistance && (Search.mvResult = c);
}
return m;
},
SearchMain: function() {
Search.Init();
var o = Date.now();
this.nDistance = 0;
for (var t = 1; t <= gCommon.LIMIT_DEPTH; t++) {
var i = this.SearchFull(-gCommon.MATE_VALUE, gCommon.MATE_VALUE, t, !1);
if (i > gCommon.WIN_VALUE || i < -gCommon.WIN_VALUE) break;
if (Date.now() - o > gCommon.CLOCKS_PER_SEC) {
console.log("search time finish");
break;
}
}
}
};